//-----------------------------------------------------------------------------
// vtSerialComm.h: inteface of the vtSerialComm class.
//
// Copyright (c) by Volker Typke 2001 (www.typke.de).
//
// Please read the comments on how to use the functions and also consult the
// help files provided with Visual C++.
//
// Revision history:
//
// Revision		Date		Changes
// ----------------------------------------------------------------------------
// 1.0.1	Jan 06. 2002	AbortRead(), AbortWrite() and FlushWriteBuffer()
//							added.
// 1.0		Dec 20, 2001	Initial version.
//-----------------------------------------------------------------------------

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class vtSerialComm  
{
public:
	enum ErrorTable
	{
		commport_ERROR_SUCCESS = 0,
		commport_ERROR_OPEN,
		commport_ERROR_GET_DCB,
		commport_ERROR_SET_DCB,
		commport_ERROR_INVALID_FLOW,
		commport_ERROR_CREATE_EVENT,
		commport_ERROR_READ,
		commport_ERROR_WRITE,
		commport_ERROR_ABORT_READ,
		commport_ERROR_ABORT_WRITE,
		commport_ERROR_FLUSH_WRITE_BUFFER
	};

	enum FlowControl
	{
		commport_FLOW_NONE = 0,
		commport_FLOW_SOFT,
		commport_FLOW_HARD,
		commport_FLOW_XONXOFF
	};

	int FlushWriteBuffer (void);
	int AbortWrite (DWORD dwFlags=PURGE_TXABORT);
	int AbortRead (DWORD dwFlags=PURGE_RXABORT);
	void SetXoffChar (char cXoffChar);
	void SetXonChar (char cXonChar);
	void SetXoffLim (WORD nXoffLim);
	void SetXonLim (WORD nXonLim);
	DWORD BytesWritten (void);
	int Write (LPVOID lpBuffer, DWORD nLength);
	int WriteOverlapped (LPVOID lpBuffer, DWORD nLength);
	void Close (void);
	int Read (LPVOID lpBuffer, DWORD nLength);
	DWORD BytesRead (void);
	int ReadOverlapped (LPVOID lpBuffer, DWORD nLength);
	DWORD GetLastSystemError();
	vtSerialComm();
	virtual ~vtSerialComm();
	int Open (LPCTSTR lpszCommPort, DWORD dwBaudRate,  BYTE byByteSize=8, BYTE byStopBits=ONESTOPBIT, BYTE byParity=EVENPARITY, BYTE byFlowControl=commport_FLOW_NONE);

protected:
	char m_cXoffChar;
	char m_cXonChar;
	DWORD m_nBytesWritten;
	DWORD m_nBytesRead;
	HANDLE m_hWriteEvent;
	HANDLE m_hReadEvent;
	OVERLAPPED m_ovWrite;
	OVERLAPPED m_ovRead;
	WORD m_nXoffLim;
	WORD m_nXonLim;
	DWORD m_nSystemError;
	DCB m_dcb;
	int m_nError;
	HANDLE m_hCommPort;
};